## glewlwyd 2.7.5

=== CMakeLists.txt ===
#
# Glewlwyd
#
# CMake file used to build program
#
# Copyright 2016-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(glewlwyd C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROGRAM_VERSION_MAJOR "2")
set(PROGRAM_VERSION_MINOR "7")
set(PROGRAM_VERSION_PATCH "5")
set(PROJECT_DESCRIPTION "Single Sign On server, OAuth2, Openid Connect, multiple factor authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via plugins ")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/glewlwyd/issues")
set(ORCANIA_VERSION_REQUIRED "2.3.2")
set(YDER_VERSION_REQUIRED "1.4.19")
set(ULFIUS_VERSION_REQUIRED "2.7.12")
set(HOEL_VERSION_REQUIRED "1.4.27")
set(RHONABWY_VERSION_REQUIRED "1.1.10")
set(IDDAWC_VERSION_REQUIRED "1.1.8")
set(LIBCBOR_VERSION_REQUIRED "0.5.0")
set(JANSSON_VERSION_REQUIRED "2.11")

set(USER_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user/")
set(USER_MODULES "")

set(USER_MIDDLEWARE_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user_middleware/")
set(USER_MIDDLEWARE_MODULES "")

set(CLIENT_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/client/")
set(CLIENT_MODULES "")

set(SCHEME_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/scheme/")
set(SCHEME_MODULES "")

set(PLUGIN_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/plugin/")
set(PLUGIN_MODULES "")

set(RESOURCES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/docs/resources/ulfius/")

include(GNUInstallDirs)
include(CheckSymbolExists)

# cmake modules

set(G_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${G_CMAKE_MODULE_PATH}")

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
  check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif ()
endif ()

if (_GNU_SOURCE)
  add_definitions(-D_GNU_SOURCE)
endif ()

set(GLWD_LIBS "-ldl -lcrypt")

find_package(Threads REQUIRED)
set(GLWD_LIBS ${GLWD_LIBS} ${CMAKE_THREAD_LIBS_INIT})

include(FindJansson)
find_package(Jansson ${JANSSON_VERSION_REQUIRED} REQUIRED)
if (JANSSON_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${JANSSON_LIBRARIES})
  include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${GNUTLS_LIBRARIES})
  include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()

include(FindNettle)
find_package(Nettle REQUIRED)
if (NETTLE_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${NETTLE_LIBRARIES})
  include_directories(${NETTLE_INCLUDE_DIRS})
endif ()

include(FindLibconfig)
find_package(Libconfig REQUIRED)
if (LIBCONFIG_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${LIBCONFIG_LIBRARIES})
  include_directories(${LIBCONFIG_INCLUDE_DIRS})
endif ()

include(FindMHD)
find_package(MHD REQUIRED)
if (MHD_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${MHD_LIBRARIES})
  include_directories(${MHD_INCLUDE_DIRS})
endif ()

include(FindZLIB)
find_package(ZLIB REQUIRED)
if (ZLIB_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif ()

# build

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
add_executable(glewlwyd ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/client.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/module.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/plugin.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/scope.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/session.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/user.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/api_key.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc_config.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/metrics.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/webservice.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.c )
set_target_properties(glewlwyd PROPERTIES COMPILE_OPTIONS "-Wextra;-Wconversion")

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during orcania search and download
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download

set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during ulfius search and download
set(BUILD_UWSC OFF CACHE BOOL "Force to false") # Avoid to build uwsc during ulfius search and download

set(SEARCH_ORCANIA_H OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during hoel search and download

set(SEARCH_ORCANIA_R OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during hoel search and download
set(SEARCH_YDER_R OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download
set(SEARCH_ULFIUS_R OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during rhonabwy search and download

set(SEARCH_ORCANIA_I OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during iddawc search and download
set(SEARCH_YDER_I OFF CACHE BOOL "Force to false") # Avoid to search and download yder during iddawc search and download
set(SEARCH_ULFIUS_I OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during iddawc search and download
set(SEARCH_RHONABWY_I OFF CACHE BOOL "Force to false") # Avoid to search and download rhonabwy during iddawc search and download

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
include(FindOrcania)
find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
if (ORCANIA_FOUND)
    if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
        message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
        include_directories(${orcania_SOURCE_DIR}/include)
    else ()
        message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
    endif ()
elseif (NOT ORCANIA_FOUND AND DOWNLOAD_DEPENDENCIES)
    include(DownloadProject)
    message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
    download_project(PROJ orcania # ... otherwise, download archive
                     URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                     QUIET)
    add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
    include_directories(${orcania_SOURCE_DIR}/include)
    add_dependencies(glewlwyd orcania)
    set(ORCANIA_LIBRARIES orcania)
    include_directories(${orcania_BINARY_DIR})
else ()
  message( FATAL_ERROR "Orcania not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${ORCANIA_LIBRARIES})

set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
include(FindYder)
find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
if (YDER_FOUND)
    if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
        message(STATUS "Yder found: ${YDER_VERSION_STRING}")
        include_directories(${yder_SOURCE_DIR}/include)
    else ()
        message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
    endif ()
elseif (NOT YDER_FOUND AND DOWNLOAD_DEPENDENCIES)
  include(DownloadProject)
  message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
  option(CHECK_ORCANIA "specific param" off)
  download_project(PROJ yder # ... otherwise, download archive
                   URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
                   QUIET)
  add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
  include_directories(${yder_SOURCE_DIR}/include)
  include_directories(${orcania_SOURCE_DIR}/include)
  add_dependencies(glewlwyd yder)
  add_dependencies(yder orcania)
  set(YDER_LIBRARIES yder)
  include_directories(${yder_BINARY_DIR})
else ()
  message( FATAL_ERROR "Yder not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${YDER_LIBRARIES})

set(Ulfius_FIND_QUIETLY ON)
include(FindUlfius)
find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
if (ULFIUS_FOUND)
    if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
        message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
        include_directories(${ulfius_SOURCE_DIR}/include)
    else ()
        message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
    endif ()
elseif (NOT ULFIUS_FOUND AND DOWNLOAD_DEPENDENCIES)
    include(DownloadProject)
    option(WITH_WEBSOCKET "specific param" off)
    option(INSTALL_HEADER "specific param" off)
    option(CHECK_YDER "specific param" off)
    message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
    download_project(PROJ ulfius
                     URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
                     QUIET)
    add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
    include_directories(${yder_SOURCE_DIR}/include)
    include_directories(${orcania_SOURCE_DIR}/include)
    include_directories(${ulfius_SOURCE_DIR}/include)
    add_dependencies(glewlwyd ulfius)
    add_dependencies(ulfius yder)
    add_dependencies(ulfius orcania)
    set(ULFIUS_LIBRARIES ulfius)
    include_directories(${ulfius_BINARY_DIR})
else ()
  message( FATAL_ERROR "Ulfius not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${ULFIUS_LIBRARIES})

set(Hoel_FIND_QUIETLY ON)
include(FindHoel)
find_package(Hoel ${HOEL_VERSION_REQUIRED} QUIET)
if (HOEL_FOUND)
    if ("${HOEL_VERSION_STRING}" VERSION_GREATER_EQUAL "${HOEL_VERSION_REQUIRED}")
        message(STATUS "Hoel found: ${HOEL_VERSION_STRING}")
        include_directories(${hoel_SOURCE_DIR}/include)
    else ()
        message( FATAL_ERROR "Hoel version required: ${HOEL_VERSION_REQUIRED} - version installed: ${HOEL_VERSION_STRING}")
    endif ()
elseif (NOT HOEL_FOUND AND DOWNLOAD_DEPENDENCIES)
    include(DownloadProject)
    option(INSTALL_HEADER "specific param" off)
    option(CHECK_YDER "specific param" off)
    message(STATUS "Download Hoel ${HOEL_VERSION_REQUIRED}")
    download_project(PROJ hoel
                     URL "https://github.com/babelouest/hoel/archive/v${HOEL_VERSION_REQUIRED}.tar.gz"
                     QUIET)
    add_subdirectory(${hoel_SOURCE_DIR} ${hoel_BINARY_DIR})
    include_directories(${hoel_SOURCE_DIR}/include)
    add_dependencies(glewlwyd hoel)
    add_dependencies(hoel yder)
    add_dependencies(hoel orcania)
    set(HOEL_LIBRARIES hoel)
    include_directories(${hoel_BINARY_DIR})
else ()
    message( FATAL_ERROR "Hoel not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${HOEL_LIBRARIES})

target_link_libraries(glewlwyd ${GLWD_LIBS})

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.4)")

execute_process(COMMAND lsb_release -is
    OUTPUT_VARIABLE DISTRIB_CODENAME_T
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

=== webapp-src/Makefile ===
#
# Glewlwyd SSO Server
#
# Makefile used to build and install the front-end webapp
#
# Copyright 2017-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

WEBAPP_DEST=../webapp
JSC=npm

all: webapp

install-dev:
	$(JSC) install

dev:
	$(JSC) run dev

webapp: build-webapp install-webapp

build-webapp:
	rm -f output/*
	$(JSC) run build

install-webapp:
	find $(WEBAPP_DEST) ! -name config.json ! -name webapp ! -name .gitignore -delete
	cp -R index.html login.html profile.html callback.html config.json.sample favicon.ico robots.txt css/ js/ locales/ fonts/ img/ $(WEBAPP_DEST)
	cp output/*.js $(WEBAPP_DEST)

=== docs/docker/Makefile ===
GLEWLWYD_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/glewlwyd/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)
ALPINE_VERSION=3.17.0

all: build

glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz:
	wget https://github.com/babelouest/glewlwyd/releases/download/v${GLEWLWYD_VERSION}/glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz

build: glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker build -t babelouest/glewlwyd:$(GLEWLWYD_VERSION) --build-arg GLEWLWYD_VERSION=$(GLEWLWYD_VERSION) --build-arg ALPINE_VERSION=$(ALPINE_VERSION) .
	docker tag babelouest/glewlwyd:$(GLEWLWYD_VERSION) babelouest/glewlwyd:latest

run:
	docker run --rm -it -p 4593:4593 babelouest/glewlwyd:latest

my-config:
	docker run --rm -it -p 4593:4593 -v $(shell pwd)/config:/etc/glewlwyd babelouest/glewlwyd

clean:
	rm -f glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker rmi -f babelouest/glewlwyd:latest babelouest/glewlwyd:$(GLEWLWYD_VERSION)
	docker system prune -f

=== src/user/Makefile ===
#
# Glewlwyd user backend
#
# Makefile used to build the software
#
# Copyright 2016-2019 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

GLWD_SRC=..
DESTDIR=/usr/local
MODULES_TARGET=$(DESTDIR)/lib/glewlwyd/user
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -Wconversion -Wno-unknown-pragmas -D_REENTRANT -Wno-pragmas -I$(GLWD_SRC) $(shell pkg-config --cflags liborcania) $(shell pkg-config --cflags libyder) $(shell pkg-config --cflags jansson) $(shell pkg-config --cflags libhoel) $(ADDITIONALFLAGS)
LIBS=$(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs jansson) -ldl
LDFLAGS += -Wl,-R '-Wl,-R$$ORIGIN'
TARGET=libmoddatabase.so libmodldap.so libmodhttp.so
all: release

misc.o: $(GLWD_SRC)/misc.c $(GLWD_SRC)/glewlwyd-common.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(GLWD_SRC)/misc.c

%.o: %.c $(GLWD_SRC)/glewlwyd.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

libmodmock.so: mock.o misc.o
	$(CC) -shared -Wl,-soname,libmodmock.so mock.o misc.o -o libmodmock.so $(LIBS) $(LDFLAGS)

libmoddatabase.so: $(GLWD_SRC)/glewlwyd-common.h database.o misc.o
	$(CC) -shared -Wl,-soname,libmoddatabase.so -o libmoddatabase.so database.o misc.o $(LIBS) $(shell pkg-config --libs libhoel)

libmodldap.so: $(GLWD_SRC)/glewlwyd-common.h ldap.o misc.o
	$(CC) -shared -Wl,-soname,libmodldap.so -o libmodldap.so ldap.o misc.o $(LIBS) -lldap -lcrypt

libmodhttp.so: $(GLWD_SRC)/glewlwyd-common.h http.o misc.o
	$(CC) -shared -Wl,-soname,libmodhttp.so -o libmodhttp.so http.o misc.o $(LIBS)

clean:
	rm -f *.o *.so

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libmodmock.so $(TARGET)

release: ADDITIONALFLAGS=-O3

release: $(TARGET)

install:
	mkdir -p $(MODULES_TARGET)
	cp -f *.so $(MODULES_TARGET)

=== debian/changelog ===
glewlwyd (2.7.5-3+deb12u1) bookworm; urgency=medium

  * d/patches: Fix CVE-2023-49208
    possible buffer overflow during FIDO2 credentials validation
  * d/patches: Fix CVE-2024-25715
    open redirection via redirect_uri

 -- Nicolas Mora <babelouest@debian.org>  Thu, 23 Nov 2023 17:12:13 -0500

glewlwyd (2.7.5-3) unstable; urgency=medium

  * Install config.json as config-2.7.json (Closes: #1035503)
  * d/glewlwyd-debian.conf.properties: disable user_middleware_module_path

 -- Nicolas Mora <babelouest@debian.org>  Thu, 04 May 2023 07:21:27 -0400

glewlwyd (2.7.5-2) unstable; urgency=medium

  * d/control: add adduser as glewlwyd package dependency, fix piuparts issue
  * d/control: Update description
  * d/control: remove lsb-base from package dependencies
  * d/NEWS: Add message on bullseye upgrade
  * d/Readme.Debian: Add readme to document bullseye transition

 -- Nicolas Mora <babelouest@debian.org>  Tue, 17 Jan 2023 07:24:23 -0500

glewlwyd (2.7.5-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/copyright: Update copyright year to 2023 for debian/* files
  * d/glewlwyd-common.install: restore link bootstrap, jquery and
    fork-awesome
  * d/glewlwyd-debian.conf.properties: disable static_files_path
  * d/glewlwyd-apache.conf: Add apache sample config file

 -- Nicolas Mora <babelouest@debian.org>  Mon, 16 Jan 2023 07:08:39 -0500

glewlwyd (2.7.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:29:50 -0400

glewlwyd (2.7.3-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update description

 -- Nicolas Mora <babelouest@debian.org>  Thu, 25 Aug 2022 07:21:46 -0400

glewlwyd (2.7.2-2) unstable; urgency=medium

  * debian/control: change dependency node-react to node-react-dom
                    Thanks to Yadd for the hint (Closes: #1014681)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 18 Jul 2022 18:05:19 +0200

=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
         , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
# Backend dependencies
             , pkg-config
             , po-debconf
             , libmicrohttpd-dev
             , libjansson-dev
             , libcurl4-gnutls-dev
             , libldap2-dev
             , libsqlite3-dev
             , libconfig-dev
             , libgnutls28-dev
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libhoel-dev
             , librhonabwy-dev
             , libiddawc-dev
             , liboath-dev
             , libcbor-dev
             , cmake
# Front-end dependencies
Build-Depends-Indep: nodejs
             , node-react-dom
             , node-babel7
             , node-babel-loader
             , node-css-loader
             , node-i18next
             , node-i18next-browser-languagedetector
             , node-i18next-http-backend
             , node-qrcode-generator
             , webpack
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.6.2
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Rules-Requires-Root: no

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
       , ${misc:Depends}
       , glewlwyd-common
       , sqlite3
       , ucf
       , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-pgsql | dbconfig-no-thanks
       , adduser
Pre-Depends: ${misc:Pre-Depends}
Suggests: rnbyc
Description: Experimental Single-Sign-On server with multiple factor authentication
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers

Package: glewlwyd-common
Depends: ${misc:Depends}
         , fonts-fork-awesome
         , libjs-jquery
         , libjs-bootstrap4
         , libjs-popper.js
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Multi-Arch: foreign
Description: Experimental Single-Sign-On server - common files
 Experimental Single Sign On server, OAuth2, Openid Connect, multiple factor
 authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via
 plugins.
 .
 It's recommended not to use Glewlwyd in production, more likely to test
 OAuth2/OpenID behavior, MFA connections, or IdP in general. You can also
 explore its functionalities and help yourself with its source code for other
 implementations.
 .
 If you intend to use it in production, it's highly recommended to follow the
 documentation and enable only the features you will use.
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 This package contains the architecture independent files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING=1

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	# add a fake empty file in webapp-src/output so dh_install will not fail
	mkdir webapp-src/output/ && touch webapp-src/output/admin.js
	# configure cmake build
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

override_dh_auto_build-indep:
	# Build webapp
	cp /usr/share/javascript/jquery/jquery.min.js webapp-src/js/
	cp /usr/share/javascript/popper.js/umd/popper.min.js webapp-src/js/
	cp /usr/share/javascript/popper.js/umd/popper-utils.min.js webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js.map webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css webapp-src/css/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css.map webapp-src/css/
	cp /usr/share/fonts-fork-awesome/css/fork-awesome.css webapp-src/css/
	cp /usr/share/fonts-fork-awesome/css/v5-compat.css webapp-src/css/
	cp /usr/share/fonts/eot/fork-awesome/forkawesome-webfont.eot webapp-src/fonts/
	cp /usr/share/fonts/svg/fork-awesome/forkawesome-webfont.svg webapp-src/fonts/
	cp /usr/share/fonts/truetype/fork-awesome/forkawesome-webfont.ttf webapp-src/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff webapp-src/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff2 webapp-src/fonts/
	(cd webapp-src && webpack --config webpack.config.js)

override_dh_auto_install:
	echo "do nothing here"

override_dh_clean:
	dh_clean --
	rm -rf webapp-src/output

=== debian/watch ===
version=4
# https://github.com/babelouest/glewlwyd
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/glewlwyd-$1/ \
 https://github.com/babelouest/glewlwyd/tags .*/v?([\d\.]+).tar.gz
